SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Compiler'!

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:47'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream parseTree translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[
		parseTree := self parserClass matchStream: origCodeStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:24'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

Object subclass: #ACTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
means

	^ 'I want to do something.'! !

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:36'!
meansOptionalTo

	^ 'I want a cake.'! !

!ACTestResource class methodsFor: 'strings-means' stamp: 'topa 5/20/2010 09:37'!
meansOptionalToWithAn

	^ 'I want an embedded sleeping hour.'! !

!ACTestResource class methodsFor: 'strings-purpose' stamp: 'topa 5/20/2010 09:36'!
purpose

	^ 'In order to achieve something.'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
role

	^ 'As a role'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:43'!
roleWithAn

	^ 'As an emancipated role'! !

!ACTestResource class methodsFor: 'strings-role' stamp: 'topa 5/20/2010 09:44'!
roleWithPlural

	^ 'As roles'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 10:07'!
userStory

	^
'A Title
In order to achieve something
As a role
I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/19/2010 13:15'!
userStoryDecompiled

	^
'userStoryATitle
	self purpose: ''achieve something''.
	self	 role: ''role''.
	self means: ''do something.''.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidNewlines

	^
'A Title
In order to achieve something

As a role

I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:27'!
userStoryInvalidOrder

	^
'A Title
As a role
I want to do something
In order to achieve something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryInvalidSyntax

	^
'A Title
In roder to achieve something
Asa role
I wnat ot do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:48'!
userStoryInvalidTrailers

	^
'A Title
In order to achieve something
As a role
I want to do something.

This is cool
'! !

!ACTestResource class methodsFor: 'strings-UserStory-invalid' stamp: 'topa 5/20/2010 09:28'!
userStoryMissingArgs

	^
'A Title
In order to
As a
I want'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:28'!
userStoryNewlineAfterTitle

	^
'A Title

In order to achieve something
As a role
I want to do something.'! !

!ACTestResource class methodsFor: 'strings-UserStory-valid' stamp: 'topa 5/20/2010 09:29'!
userStorySpacing

	^
'A Title
    In order to achieve something
	As a role
 	 I want to do something.'! !

Object subclass: #ACUserStoryContainer
	instanceVariableNames: 'purpose role means'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStoryContainer subclass: #ACPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACPlayground methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
A Title
In order to achieve something
As a role
I want to do something.! !

!ACPlayground methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
Driving
In order to reach my destination
As a car owner
I want to be able to drive.! !

!ACUserStoryContainer class methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:18'!
compilerClass

	^ self == ACUserStoryContainer
		ifTrue: [super compilerClass]
		ifFalse: [ACCompiler]! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
means

	^means! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
means: anObject

	means := anObject! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
purpose

	^purpose! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
purpose: anObject

	purpose := anObject! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
role

	^role! !

!ACUserStoryContainer methodsFor: 'accessing' stamp: 'topa 5/19/2010 13:20'!
role: anObject

	role := anObject! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:21'!
testUserStoryCompilation

	| acMethod stMethod |

	acMethod := ACCompiler new compile: ACTestResource userStory  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: ACTestResource userStoryDecompiled in: self class classified: nil notifying: nil ifFail: [].

	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

TestCase subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:13'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:47'!
testUserStoryInvalidNewlinesMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:47'!
testUserStoryInvalidOrderMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:48'!
testUserStoryInvalidSyntaxMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:48'!
testUserStoryInvalidTrailersMatch

	self shouldnt: [self match: ACTestResource userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:40'!
testUserStoryMatch

	self should: [self match: ACTestResource userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:46'!
testUserStoryMeansMatch

	self should: [self match: ACTestResource means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:38'!
testUserStoryMeansOptionalToMatch

	self should: [  self match: ACTestResource meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:38'!
testUserStoryMeansOptionalToWithAnMatch

	self should: [  self match: ACTestResource meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:49'!
testUserStoryMissingArgsMatch

	self shouldnt: [self match: ACTestResource userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:51'!
testUserStoryNewlineAfterTitleMatch
	
	self should: [self match: ACTestResource userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:34'!
testUserStoryPurposeMatch

	self should: [  self match: ACTestResource purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleMatch

	self should: [ self match: ACTestResource role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleWithAnMatch

	self should: [ self match: ACTestResource roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/20/2010 09:41'!
testUserStoryRoleWithPluralMatch

	self shouldnt: [ self match: ACTestResource roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'topa 5/20/2010 09:51'!
testUserStorySpacingMatch
	
	self should: [self match: ACTestResource userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 09:39'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 10:03'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:21'!
rule =

	{symbol:s string:body} -> ['	self ', s asMutator,' ''', body,'''.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:10'!
title =

	{symbol:t string:s} -> ['userStory', s asLegalSelector capitalized, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 13:08'!
translate =
	
	{symbol:type title:t rule:purpose rule:role rule:means}
		-> [t, purpose, role, means]! !
